#include "labgen.h"
Point size; /*Attention c'est la taille de l'énoncé. */
/* char *** matrice = NULL ; */
int in,out;
variables listevars;


/* Crée un nouveau point de coordonnées (c,l)
 * --> Attention : l'ordre n'est pas logique (colonne, ligne)
 */
Point new_point(int c, int l)
{
  Point monpoint;
  monpoint.c = c;
  monpoint.l = l;
  return monpoint;
}


/* Crée une matrice de taille (s1, s2)
 * --> Attention : l'ordre n'est pas logique (colonne, ligne)
 * s1 est le nombre de colonnes
 * s2 est le nombre de lignes
 * Implémentation de la matrice en mode naturel <-------
 * /!\ Attention : toujours créer la matrice avant d'utiliser
 * les autres fonctions */
char*** create_matrice(int s1, int s2)
{
  int i,j;
  char*** matrice = malloc((s2+1)*sizeof(char **));

  for (i= 0; i<=s2; i++){
      matrice[i] = malloc((s1+1) * sizeof(char *));
      for (j=0; j<=s1; j++) {
        matrice[i][j] = malloc(sizeof(char));
        strcpy(matrice[i][j],"");
      }
  }
  size = new_point(s1,s2);
  in = 0;
  out = 0;
  return matrice;
}


/* Renvoie la valeur de la matrice de coordonnées p */
char* lecture(Point p, char*** matrice)
{
  if (matrice == NULL){
    printf("Matrice non initialisée.\n");
  }
  else if (p.c >= 0 && p.l >= 0 && p.c <= size.c && p.l <= size.l){
    return matrice[p.l][p.c];
  }
  else
    printf("Impossible de lire la valeur au point (%d,%d).\n", p.c,p.l);
  return NULL;
}


/* void stock_val */
/* Change la valeur de la matrice de coordonnées p par la valeur msg */
void change_val_matrice(Point p, char * msg, char*** matrice)
{
  if (matrice == NULL){
    printf("Matrice non initialisée.\n");
  }

  else if (p.c >= 0 && p.l >= 0 && p.c <= size.c && p.l <= size.l) {
      char * m1;
      m1 = malloc(strlen(msg)*sizeof(char));
      strcpy(m1,msg);
      if (matrice[p.l][p.c] != NULL){
        free(matrice[p.l][p.c]) ;
      }
      matrice[p.l][p.c] = m1;
  }
  else {
    printf("Impossible de changer de valeur la valeur au point (%d,%d).\n",
      p.c,p.l);
  }
}



/*void ligne(){
  int	j;
  for (j=0;j<size.l;j++)
    printf(" -------");
  printf("\n");
}*/

void affichmat(char*** matrice) {
  int	i,j;

  /*ligne();*/
  for(i=0;i<=size.l;i++){
    for(j=0;j<=size.c;j++){
      printf("|%s \t",matrice[i][j]);
    }
    printf("|\n");
    /*ligne();*/
  }
  /*ligne();*/
}



/* Initialise listevars */
void init_listevars(){
  listevars.last = 0;
}


/* Vérifie si var est dans listevars :
 * - si oui, renvoie l'adresse correspondante
   - sinon, renvoie NULL */
int find_var(char* var) {
  int i;
  int ret;

  for (i=0; i<listevars.last; i++) {
    ret = strcmp(listevars.ident[i], var);
    if (ret==0) {
    return i;
    }
  }
  return -1;
}


/* Modifie la valeur de la variable :
 * - Si "nom" fait partie de la liste des variables, alors la variable est
 *   directement modifiée
 * - Sinon rajoute le nom de la variable et sa valeur dans listevars
     si la taille de listevars le permet */
void create_modif_var(char* nom, int val) {
  int index = find_var(nom);

  if (index != -1)
  {
    listevars.val[index] = val;
  }

  else{
  	if (listevars.last > TAILLE) {
    	printf("Il n'y a plus de place pour tous ces variables.\n");
    	exit(1);
  	}
  	else
   	  listevars.ident[listevars.last] = malloc(strlen(nom)*sizeof(char));

   	strcpy(listevars.ident[listevars.last],nom);
   	listevars.val[listevars.last] = val;
   	listevars.last++;
  }
}


/* Règles sémantiques :
 * Retourne 1 quand c'est correct
 * Retourne 0 sinon */

/* RS1 : Le labyrinthe doit avoir au moins 2 lignes et au moins 2 colonnes */
int RS1(Point size){
  if (size.c >= 1 && size.l >= 1)
    return 1;
  printf("RS1 : Le labyrinthe doit avoir au moins 2 lignes et au moins 2 colonnes.\n");
  return 0;
}

/* RS2_count : Le labyrinthe doit avoir une et une seule entrée */
int RS2_count(int countE){
  if (countE == 1)
    return 1;
  printf("RS2 : Le labyrinthe doit avoir une et une seule entrée.\n");
  return 0;
}

/* RS2_check : L'entrée ne peut être ni une sortie ni une entrée de trou de vers */
int RS2_check(){
  /* A faire */
  return 0;
}

/* RS3_count : Le labyrinthe doit avoir au moins une sortie */
int RS3_count(int countS){
  if (countS >= 1)
    return 1;
  printf("RS3 : Le labyrinthe doit avoir au moins une sortie.\n");
  return 0;
}

/* RS3_check : La sortie ne peut être ni l'entrée ni une entrée de trou de vers */
int RS3_check(){
  /* A faire */
  return 0;
}

/* RS4 : L'entrée et les sorties du labyrinthe doivent se situer sur la périphérie
 * du labyrinthe
 * E est le point d'entrée
 * S est un tableau dynamique de l'ensemble des sorties
 * nb_S est le nombre de sorties
 * size est un point donnant la taille du tableau */
int RS4(Point E, Point* S, int nb_S, Point size){
   int i;
   Point tmp;

   if (S == NULL){
     fprintf(stderr,"RS4 : La liste des sorties est non initialisée.\n");
     exit(1);
   }

   else if (nb_S == 0){
     printf("RS4 : La liste des sorties est vide.\n");
     return 0;
   }

   /* Vérification pour l'entrée */
   else if (E.c != 0 && E.l != 0 && E.c != size.c && E.l != size.l){
      return 0;
   }

   /* Vérification pour toutes les sorties */
   else {
     for (i=0 ; i<nb_S ; i++){
       tmp = S[i];
       if (tmp.c != 0 && tmp.l != 0 && tmp.c != size.c && tmp.l != size.l){
          return 0;
       }
     }
   }
   return 1;
 }


/* Test des fonctions pour les règles sémantiques */
int main(){
  char*** matrice = create_matrice(5,6);
  Point size = new_point(5,6);

  Point entree1 = new_point(0,0);
  Point entree2 = new_point(5,6);
  Point entree3 = new_point(5,0);
  Point entree4 = new_point(0,5);

  change_val_matrice(entree1,"E",matrice);
  change_val_matrice(entree2,"E",matrice);
  change_val_matrice(entree3,"E",matrice);
  change_val_matrice(entree4,"E",matrice);


  Point* listeS = NULL;
  listeS = calloc(1,sizeof(Point));
  listeS[0] = new_point(5,6);
  /* A tester : pour plusieurs sorties */
  change_val_matrice(new_point(5,6),"S",matrice);
  affichmat(matrice);

  printf("\nlisteS[0] : (%d,%d)\n",listeS[0].c, listeS[0].l);

  printf("Test entree1 : %d\n", RS4(entree1,listeS,1,size));
  printf("Test entree2 : %d\n", RS4(entree2,listeS,1,size));
  printf("Test entree3 : %d\n", RS4(entree3,listeS,1,size));
  printf("Test entree4 : %d\n", RS4(entree4,listeS,1,size));


  return 0;
}



/* Test des fonctions de base de la matrice et de listevars */
/*int main () {
  char*** matrice = create_matrice(5,6);

  Point p1 = new_point(4,2);
  printf("Point p1 (%d,%d)\n",p1.c,p1.l);

  printf("\nAppel de la fonction change_val_matrice(p1,ABC)\n");
  change_val_matrice(p1,"ABC",matrice);
  printf("Point p1 :%s\n", lecture(p1,matrice));
  printf("\nAppel de la fonction change_val_matrice(p1,DEF)\n");
  change_val_matrice(p1, "DEF", matrice);
  printf("Point p1 :%s\n", lecture(p1,matrice));

  printf("\nTaille de la matrice : (%d,%d)\n",size.c,size.l);
  printf("Matrice correspondante :\n");
  affichmat(matrice);

  init_listevars();
  create_modif_var("IDENT",1);
  create_modif_var("IDENT",2);
  create_modif_var("IDENT",1);
  create_modif_var("IDENT2",5);
  printf("\n\nTaille listevars : %d\n",listevars.last);
  printf("Premier nom : %s\n",listevars.ident[0]);
  printf("Première valeur : %d\n",listevars.val[0]);
  printf("Deuxième nom : %s\n",listevars.ident[1]);
  printf("Deuxième valeur : %d\n",listevars.val[1]);

  return 0;
}*/
